//+------------------------------------------------------------------+
//|                                                    Points_ZZ.mq4 |
//+------------------------------------------------------------------+
#property copyright "figar0"
#property link      "figaro@mail.ru"

#property indicator_chart_window
#property indicator_buffers 3
#property indicator_color1 Gold
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width1 2

//---- indicator parameters
extern int    Points      = 50; 
extern bool   ShowAllPeak = true; 

//---- indicator buffers
double zzL[];
double zzH[];
double zz[];
int GlobalMove=0,  LocalMove=0,  GlobalPeakT,  LocalPeakT,   TimeHold=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
//---- drawing settings
   SetIndexStyle(2,DRAW_ARROW);
   SetIndexStyle(1,DRAW_ARROW);
   SetIndexStyle(0,DRAW_SECTION);
   SetIndexArrow(2,174);
   SetIndexArrow(1,174);
//---- indicator buffers mapping
   SetIndexBuffer(0,zz);
   SetIndexBuffer(1,zzH);
   SetIndexBuffer(2,zzL);
   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexEmptyValue(2,0.0);

//---- indicator short name
   IndicatorShortName("Point_ZZ("+Points+")");
//---- initialization done
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
{
  int Limit = Bars-IndicatorCounted()-1;
  for (int shift=Limit; shift>=0; shift--)
  {
    if (Time[shift]!=TimeHold)
    {
      TimeHold=Time[shift]; LocalMove=0;
      if (zz[shift+1]!=0 && zzL[shift+1]!=0) {GlobalMove=-1; GlobalPeakT=Time[shift+1];}   
      if (zz[shift+1]!=0 && zzH[shift+1]!=0) {GlobalMove= 1; GlobalPeakT=Time[shift+1];}
    }
    if (GlobalMove==1 && zz[iBarShift(NULL,0,GlobalPeakT)]<=High[shift])
    {
      if (LocalMove==-1)
      {
        zz[iBarShift(NULL,0,LocalPeakT)]=0;      
        zzL[iBarShift(NULL,0,LocalPeakT)]=0;           
        LocalMove=0;
      }
      zz[iBarShift(NULL,0,GlobalPeakT)]=0;
      if (!ShowAllPeak) zzH[iBarShift(NULL,0,GlobalPeakT)]=0;
      zz[shift]=High[shift];
      zzH[shift]=High[shift]; 
      zzL[shift]=0;     
      GlobalPeakT=Time[shift];
      GlobalMove=1;
      continue;
    }
    if (GlobalMove==-1 && zz[iBarShift(NULL,0,GlobalPeakT)]>=Low[shift])
    {
      if (LocalMove==1)
      {
        zz[iBarShift(NULL,0,LocalPeakT)]=0;      
        zzH[iBarShift(NULL,0,LocalPeakT)]=0;           
        LocalMove=0;
      }    
      zz[iBarShift(NULL,0,GlobalPeakT)]=0;
      if (!ShowAllPeak) zzL[iBarShift(NULL,0,GlobalPeakT)]=0;      
      zz[shift]=Low[shift];
      zzL[shift]=Low[shift]; 
      zzH[shift]=0;     
      GlobalPeakT=Time[shift];
      GlobalMove=-1;
      continue;
    }     
    if (High[shift]>=zz[iBarShift(NULL,0,GlobalPeakT)]+Points*Point)
    {
      zz[shift]=High[shift];
      zzH[shift]=High[shift];    
      zzL[shift]=0; 
      LocalPeakT=Time[shift];
      LocalMove=1;   
      continue;
    }    
    if (Low[shift]<=zz[iBarShift(NULL,0,GlobalPeakT)]-Points*Point)
    {
      zz[shift]=Low[shift];
      zzL[shift]=Low[shift];    
      zzH[shift]=0; 
      LocalPeakT=Time[shift];
      LocalMove=-1;             
      continue; 
    }
  }

  return(0);
}
//+------------------------------------------------------------------+